"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var ajv_1 = __importDefault(require("ajv"));
var loader_utils_1 = __importDefault(require("loader-utils"));
var path_1 = __importDefault(require("path"));
var assert_ts_1 = require("assert-ts");
var standalone_1 = __importDefault(require("ajv/dist/standalone"));
function makeStandalone(schemaStr, sourceMap) {
    var _this = this;
    var _a;
    var done = this.async();
    (0, assert_ts_1.assert)(!!done, "no done function");
    var loadSchema = function (uri) {
        var filePath = path_1.default.resolve(_this.context, uri);
        return new Promise(function (resolve, reject) {
            try {
                // eslint-disable-next-line @typescript-eslint/no-var-requires
                var schema_1 = require(filePath);
                resolve(schema_1);
            }
            catch (e) {
                e.message = "Couldn't load schema: ".concat(e.message);
                reject(e);
            }
        });
    };
    var options = loader_utils_1.default.getOptions(this) || {};
    var loaderOptions = (_a = options.ajv) !== null && _a !== void 0 ? _a : {};
    var ajvOptions = __assign(__assign({ loadSchema: loadSchema }, loaderOptions), { code: { source: true } });
    var ajv = new ajv_1.default(ajvOptions);
    var schema;
    try {
        schema = JSON.parse(schemaStr);
    }
    catch (e) {
        e.message = "Schema is not a valid JSON: ".concat(e.message);
        done(e);
        return;
    }
    ajv.compileAsync(schema).then(function (validate) {
        var moduleCode = (0, standalone_1.default)(ajv, validate);
        done(null, moduleCode, sourceMap);
    }, function (e) {
        done(e);
    });
}
exports.default = makeStandalone;
//# sourceMappingURL=index.js.map